<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Template Parser Class</h1>

		<p>The template parser class allows you to parse pseudo-variables contained within your views.  It can
		parse simple variables or variable tag pairs.  If you've never used a template engine pseudo-variables
		look like the following.</p>

		<div class="example">
			&lt;html&gt;<br />
			&lt;head&gt;<br />
			&lt;title&gt;{blog_title}&lt;/title&gt;<br />
			&lt;/head&gt;<br />
			&lt;body&gt;<br />
			<br />
			&lt;h3&gt;{blog_heading}&lt;/h3&gt;<br />
			<br />
			{blog_entries}<br />
			&lt;h5&gt;{title}&lt;/h5&gt;<br />
			&lt;p&gt;{body}&lt;/p&gt;<br />
			{/blog_entries}<br />
			&lt;/body&gt;<br />
			&lt;/html&gt;
		</div>

		<p>These variables are not PHP variables, but text representations that allow you to remove PHP
		from your templates/views.</p>

		<p><i>Note:</i> CarbonPHP does not require you to use the template parser class since using pure PHP
		in the view files is a little faster.  Some developers prefer to use a template engine if they work
		with designers who are confused with PHP code in the templates/views.</p>

		<p>The template parser class is not a full-blown template parsing engine, like Smarty.</p>
	</div>

	<div class="content">
		<h1>Initialising the Template Parser</h1>
		
		<p>The template parser is loaded using the <b>$this->load->library()</b> method.</p>

		<div class="example">
			$this->load->library('parser');
		</div>

		<p>The parser will be available via the <b>$this->parser</b> object.
	</div>

	<div class="content">
		<h1>$this->parser->parse()</h1>
		
		<p>This method accepts a template name and a data array as parameters, it will generate a parsed
		version.</p>

		<div class="example">
			$this->load->library('parser');<br />
			<br />
			$data = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'blog_title' => 'My Weblog',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'blog_heading' => 'Welcome to My Web Log'<br />
			)<br />
			<br />
			$this->parser->parse('blog_template', $data);
		</div>

		<p>The first parameter is the name of the view file and the seond parameter contains an associative array
		of data to be replaced in the template.  In the example above the template would contain two variables:
		<b>{blog_title}</b> and <b>{blog_heading}</b>.</p>

		<p>There is no need to echo or do something with the return data, it is automatically passed to the output
		class to be sent to the browser.  However if you wish to have the data returned instead of sent to
		the output class you can pass <b>true</b> to the third parameter.</p>

		<div class="example">
			$output = $this->parser->parse('blog_template', $data, true);
		</div>
	</div>

	<div class="content">
		<h1>Variable Pairs</h1>

		<p>The above code allows simple variables to be replaced.  If you would like an entire block of variables
		to be repeated, with each iteration containing new data, you can use variable pairs.</p>

		<div class="example">
			&lt;html&gt;<br />
			&lt;head&gt;<br />
			&lt;title&gt;{blog_title}&lt;/title&gt;<br />
			&lt;/head&gt;<br />
			&lt;body&gt;<br />
			<br />
			&lt;h3&gt;{blog_heading}&lt;/h3&gt;<br />
			<br />
			{blog_entries}<br />
			&lt;h5&gt;{title}&lt;/h5&gt;<br />
			&lt;p&gt;{body}&lt;/p&gt;<br />
			{/blog_entries}<br />
			&lt;/body&gt;<br />
			&lt;/html&gt;
		</div>

		<p>In the above code you will see pairs of variables <b>{blog_entries}</b> and <b>{/blog_entries}</b>.  In
		a case like this, the entire chuck of data between these pairs would be repeated multiple times.</p>

		<p>Parsing variable pairs is done using the same code shown previously except you add a multi-dimension
		array corresponding to your variable pair data.</p>

		<div class="example">
			$this->load->library('parser');<br />
			<br />
			$data = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'blog_title' => 'My Weblog',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'blog_heading' => 'Welcome to My Web Log'<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'blog_entries' => array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;array('title' => 'Title 1', 'body' => 'Body 1'),<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;array('title' => 'Title 2', 'body' => 'Body 2'),<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;array('title' => 'Title 3', 'body' => 'Body 3'),<br />
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;array('title' => 'Title 4', 'body' => 'Body 4'),<br />
			&nbsp;&nbsp;&nbsp;&nbsp;)<br />
			)<br />
			<br />
			$this->parser->parse('blog_template', $data);
		</div>

		<p>If your pair data is coming from a database query result, which is already a multi-dimension array, you
		can use the database result method to supply the data.</p>

		<div class="example">
			$this->load->library('parser');<br />
			<br />
			$data = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'blog_title' => 'My Weblog',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'blog_heading' => 'Welcome to My Web Log'<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'blog_entries' => $query->result_array()<br />
			)<br />
			<br />
			$this->parser->parse('blog_template', $data);
		</div>
	</div>
</body>

</html>
